'  DateFunctions_v4

----------------------------------
Update DaysInMonth Calendar Functions
----------------------------------
AdjBack2JulianTradeDate
DayOfWeekJulian      --> OK - No Changes from v3.8.4.0
DaysBetweenDates     --> 
DaysInMonth          --> Now  Uses TB New Function
GetCalendarDayName   --> 
GetDatesClosestBarNum--> 
GetJulianDayName     --> 
GetLongMonthName     --> 
GetMonthLastTradeDate--> OK
GetMonthTradeDays    --> OK
GetMonthDayCountStr  --> OK
GetNextOrderDate     --> OK
LastDayOccurance     --> OK
LastTradeDateOfMonth --> OK
NextBiWeekDate       --> OK
NextDayOfWeekDate    --> 

----------------------------------
===================  SCRIPT_CHANGE:
AdjBack2JulianTradeDate
===================  SCRIPT_CHANGE:
DaysBetweenDates
===================  SCRIPT_CHANGE:
GetCalendarDayName
===================  SCRIPT_CHANGE:
GetDatesClosestBarNum
===================  SCRIPT_CHANGE:
GetJulianDayName
===================  SCRIPT_CHANGE:
GetLongMonthName
===================  SCRIPT_CHANGE:
DayOfWeekJulian

   '  ==============================================================
   '   SCRIPT NAME:     DayOfWeekJulian
   '   BLOX TYPE:       Script FUNCTION 
   '   CODE VERSION:    1.0    
   '   CREATION DATE:   20080727
   '   LAST UPDATE:     20080820
   '   TRADING BLOX:    2.3.b7 or later
   '   PROGRAMMER:      Roger Rines
   '  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   '   DESCRIPTION:  This function returns the Day of Week Number 
   '                 from Julian Date Number it gets.
   '                 Sunday = 0 to Saturday = 6   
   '   USE: When the Date is a Julian Number and the Day of the Week
   '	      value is needed.
   '
   '   CODE FUNCTION CALL:
   '     Function_Result = Script.Execute( "DayOfWeekJulian", JulianNumber )
   '        OR
   '     PRINT Script.Execute( "DayOfWeekJulian", JulianNumber )
   '  --------------------------------------------------------------
   '  DayOfWeekJulian - FUNCTION START
   '  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   '  Function Parameter Variables
   VARIABLES: JulianNumber_DoWJ        Type: Integer
   '  Function Working Variables
   VARIABLES: DayNum_DoWJ              Type: Integer
   '  --------------------------------------------------------------
   '  Assign ParameterList Items to Parameter Variables
   JulianNumber_DoWJ = script.parameterList[1]  '  INTEGER
   '  --------------------------------------------------------------
   '  Ensure There is Correct Calling Information
   If JulianNumber_DoWJ < 1 THEN 
      '  EXIT FUNCTION
      DayNum_DoWJ = -1   '  Report Error
   ELSE
      '  Calculate Day Of Week Value    
      DayNum_DoWJ = JulianNumber_DoWJ  MOD 7 
   ENDIF '  JulianNumber_DoWJ = 0
   '  --------------------------------------------------------------
   '  Return Function Value
   script.SetReturnValue( DayNum_DoWJ )
   '  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   '  DayOfWeekJulian - FUNCTION END
   '  ==============================================================

===================  SCRIPT_CHANGE:
DaysBetweenDates
===================  SCRIPT_CHANGE:
DaysInMonth
===================  SCRIPT_CHANGE:
GetCalendarDayName
===================  SCRIPT_CHANGE:
GetDatesClosestBarNum
===================  SCRIPT_CHANGE:
GetJulianDayName
===================  SCRIPT_CHANGE:
GetLongMonthName
===================  SCRIPT_CHANGE:
GetMonthLastTradeDate

   '  ==============================================================
   '   SCRIPT NAME:     GetMonthLastTradeDate
   '   BLOX TYPE:       Script FUNCTION
   '   CODE VERSION:    1.0    
   '   CREATION DATE:   20140122
   '   LAST UPDATE:     20140122
   '   TRADING BLOX:    4.3
   '   PROGRAMMER:      Roger Rines
   '  --------------------------------------------------------------
   '   DESCRIPTION:  Function Get Month's Last Trade-Date
   '
   '   USE: Date validity test.
   '   
   '   CODE FUNCTION CALL:
   '     Function_Result = script.Execute("GetMonthLastTradeDate", _
   '                                         iYMDDate)
   '        OR
   '     PRINT script.Execute("GetMonthLastTradeDate", iYMDDate)
   '  --------------------------------------------------------------
   '  GetMonthLastTradeDate FUNCTION - START
   '  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   '  Function Parameter Variables
   VARIABLES: iDate_GNT, iYr_GNT, iMth_GNT, iDay_GNT  Type: Integer
   VARIABLES: iDateOK_GNT, iNextDate_GNT              Type: Integer
   '  --------------------------------------------------------------
   '  Send Parameter to Working variable
   iDate_GNT = script.parameterList[1]  '  INTEGER

   '  Test Date Validity
   iDateOK_GNT = script.Execute("IsValidDate", iDate_GNT)   

   '  Ensure Date is within range
   If iDateOK_GNT THEN
      '  Parse into date components
      iYr_GNT = Year(iDate_GNT)
      iMth_GNT = Month(iDate_GNT)
      iDay_GNT = DayOfMonth(iDate_GNT)

      '  Get parse date items to find last trade date
      iNextDate_GNT = script.Execute( "LastTradeDateOfMonth", _
                                          iYr_GNT, iMth_GNT )
      '  If Month's Last Trade Date 
      If iNextDate_GNT < iDate_GNT THEN
         '  Increment Month Value
         iMth_GNT = iMth_GNT + 1
         
         '  Keep dates real
         If iMth_GNT > 12 THEN
            '  Increment Year
            iYr_GNT = iYr_GNT + 1
            '  Use first month of next year
            iMth_GNT = 1   
            
            '  Get Next Trade Possible End-of-Month Date
            iNextDate_GNT = script.Execute( "LastTradeDateOfMonth", _
                                                iYr_GNT, iMth_GNT )
         ENDIF '  iMth_GNT > 12
      ENDIF '  iNextDate_GNT > iDate_GNT      
   ELSE
      '  Generate Error Date
      iNextDate_GNT = -1
   ENDIF '  iDate_GNT > 19900101 AND iDateOK_GNT
   '  --------------------------------------------------------------
   '  Return Function Value
   script.SetReturnValue( iNextDate_GNT )
   '  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   '  GetMonthLastTradeDate FUNCTION - END
   '  ==============================================================

===================  SCRIPT_CHANGE:
   '  ==============================================================
   '   SCRIPT NAME:     GetMonthDayCountStr
   '   BLOX TYPE:       Script FUNCTION
   '   CODE VERSION:    1.0    
   '   CREATION DATE:   20100225
   '   LAST UPDATE:     20140123
   '   TRADING BLOX:    4.0 or later
   '   PROGRAMMED BY:   Roger Rines
   '  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   '   DESCRIPTION:  Function creates a comma delimited string of the
   '                 the number of days in each month for in the year
   '                 provided.
   '      Example String Returns:
   '      ~~~~~~~~~~~~~~~~~~~~~~~
   '         Number of Days in a Month
   '           '  Non-LEAP-YEAR 
   '           sMthDayCount = "31,28,31,30,31,30,31,31,30,31,30,31"
   '           '  LEAP-YEAR
   '           sMthDayCount = "31,29,31,30,31,30,31,31,30,31,30,31"
   
   '   USE: String return provides data for a fast days in a month
   '      lookup process.  Return String needs to be rebuilt when
   '      the data year changes so the return values for February
   '      will be correct
   '      
   '      Example Code Use of Return:
   '         '  Number of Days in a Non-Leap-Year Month
   '         Month_Days = GetField(sMthDayCount, Bar_Mth)
   '
   '   CODE FUNCTION CALL:
   '     Result = Script.Execute( "GetMonthDayCountStr", nYear )
   '        OR
   '     PRINT Script.Execute( "GetMonthDayCountStr", nYear )
   '  --------------------------------------------------------------
   '  GetMonthDayCountStr FUNCTION - START
   '  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   VARIABLES: nYear_GMDCS, nDays_GMDCS    Type: Integer
   VARIABLES: sDaysInMth_GMDCS            Type: String
   '  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   '  Assign ParameterList Items to Parameter Variables
   '  so that Code is Self-Documenting, and so users can
   '  easily see parameter requirements.
   nYear_GMDCS = script.parameterList[1]  '  INTEGER
   '  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
   '  Reset
   sDaysInMth_GMDCS = ""
   
   '  If nYear is within range,...
   If nYear_GMDCS > 1900 THEN
      '  Get Number of Days in February of Provided Year
      'nDays = Script.Execute( "DaysInMonth", nYear, 2)
      nDays_GMDCS = DaysInMonth( nYear_GMDCS, 2)
      '  Select by Leap Year Result
      If nDays_GMDCS = 29 THEN
         '  Number of Days in a LEAP-YEAR Month
         sDaysInMth_GMDCS = "31,29,31,30,31,30,31,31,30,31,30,31"
      ELSE
         '  Number of Days in a Non-LEAP-YEAR Month
         sDaysInMth_GMDCS = "31,28,31,30,31,30,31,31,30,31,30,31"
      ENDIF '  nDays_GMDCS
   ENDIF   
   '  --------------------------------------------------------------
   '  Return Function Value
   script.SetReturnValue( sDaysInMth_GMDCS )
   '  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   '  '  GetMonthDayCountStr FUNCTION - END
   '  ==============================================================

===================  SCRIPT_CHANGE:
GetMonthLastTradeDate
===================  SCRIPT_CHANGE:
GetLongMonthName
===================  SCRIPT_CHANGE:

   '  ==============================================================
   '   SCRIPT NAME:     GetMonthTradeDays
   '   BLOX TYPE:       Script FUNCTION 
   '   CODE VERSION:    1.0    
   '   CREATION DATE:   20080727
   '   LAST UPDATE:     20140123
   '   TRADING BLOX:    4.1 or later
   '   PROGRAMMER:      Roger Rines
   '  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   '   DESCRIPTION:  This function creates a list of Julian Dates that
   '                 fall on Weekday numbers 1 through 5.
   '                 
   '                 Each weekday/tradeday found is then stored in a BPV
   '                 series array named: MonthTradeDatesJulian[x]
   '                 
   '                 MonthTradeDatesJulian is a manually index array that
   '                 starts at 1 for the first weekday in the month, and
   '                 ends at the array size value for the last day in the
   '                 month.   
   '   USE: 
   '     nYear  = 2007  '  Year for Month
   '     nMonth = 2     '  February
   '     
   '     After this Function is called, any trade day in the month can be
   '     located by using its series index value.  For example, to get the
   '     first trade day in the month:
   '        '  Returns First Trade Day
   '        JulianDateValue = MonthTradeDatesJulian[1]
   '
   '   CODE FUNCTION CALL:
   '     TradeDayCount = Script.Execute( "GetMonthTradeDays", nYear, nMonth )
   '         OR
   '     PRINT Script.Execute( "GetMonthTradeDays", nYear, nMonth )
   '  --------------------------------------------------------------
   '  GetMonthTradeDays FUNCTION - START
   '  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   '  Function Parameter Variables
   VARIABLES: nYear_GMTD, nMonth_GMTD Type: Integer

   '  Function Working Variables
   VARIABLES: DayNum_GMTD                                   Type: Integer
   VARIABLES: JulianDateNumber_GMTD, JulianDayMonthEnd_GMTD Type: Integer
   VARIABLES: MonthDayCount_GMTD, TradeDayCount_GMTD        Type: Integer
   VARIABLES: TradeDayIndex_GMTD , lResult_GMTD             Type: Integer
   '  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   '  Assign ParameterList Items to Parameter Variables
   '  so that Code is Self-Documenting, and so users can
   '  easily see parameter requirements.
   nYear_GMTD = script.parameterList[1]  '  INTEGER
   nMonth_GMTD = script.parameterList[2]  '  INTEGER
   '  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   '  Ensure There is Correct Calling Information
   If nYear_GMTD = 0 OR nMonth_GMTD = 0 THEN 
      '  EXIT FUNCTION
      TradeDayCount_GMTD = -1   '  Report Error
   ELSE         
      '  Erase Previous Trade Date Series Elements
      'lResult = SetSeriesSize(MonthTradeDatesJulian, 1 )
      SetSeriesSize(MonthTradeDatesJulian, 1 )
      
      '  Clear Remaining Series Element
      MonthTradeDatesJulian[1] = 0

      '  Find the number of days in the month
      'MonthDayCount = Script.Execute( "DaysInMonth", nYear, nMonth)
      MonthDayCount_GMTD = DaysInMonth( nMonth_GMTD,  nYear_GMTD )
      '  Calculate the Julian number for the first day of the month
      JulianDateNumber_GMTD = DateToJulian((nYear_GMTD _
                                             * 10000) _
                                             + (nMonth_GMTD * 100) + 1)
      
      '  Calculate the Julian number for the Lasy day of the month
      JulianDayMonthEnd_GMTD = DateToJulian((nYear_GMTD _
                                             * 10000) _
                                             + (nMonth_GMTD * 100) _
                                             + MonthDayCount_GMTD)
      '  Initialize Index Locator
      TradeDayIndex_GMTD = 0                                                       

      '  Create An Array To Hold The Month's Trade Dates
      'lResult = SetSeriesSize(MonthTradeDatesJulian, MonthDayCount )
      SetSeriesSize(MonthTradeDatesJulian, MonthDayCount_GMTD )
            
      '  Create a List of Trade Dates for This Month
      While JulianDateNumber_GMTD <= JulianDayMonthEnd_GMTD
         '  Get the Weekday Number for this Julian Date
         DayNum_GMTD = script.Execute( "DayOfWeekJulian", _
                                          JulianDateNumber_GMTD )
         '  0 = Sunday, 6 = Saturday
         '	If this is a Trade date,...
         If DayNum_GMTD > SUNDAY AND DayNum_GMTD < SATURDAY THEN
            '  Incrment Index Locator
            TradeDayIndex_GMTD = TradeDayIndex_GMTD + 1
            '  Record Julian Number
            MonthTradeDatesJulian[TradeDayIndex_GMTD] = JulianDateNumber_GMTD
         ENDIF

         '  Incrment Julian Date Value
         JulianDateNumber_GMTD = JulianDateNumber_GMTD + 1      
      ENDWHILE '  JulianDateNumber <= JulianDayMonthEnd

      '  Adjust Array Of Month's Trade Dates To Match Index
      'lResult = SetSeriesSize(MonthTradeDatesJulian, TradeDayIndex )
      SetSeriesSize(MonthTradeDatesJulian, TradeDayIndex_GMTD )

      '  Retrieve the Julian Date at the Adjusted TradeDayIndex Location
      TradeDayCount_GMTD = TradeDayIndex_GMTD
   ENDIF '  nYear = 0 OR nMonth = 0
   '  --------------------------------------------------------------
   '  Return Function Value
   script.SetReturnValue( TradeDayCount_GMTD )
   '  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   '  GetMonthTradeDays FUNCTION - END
   '  ==============================================================

===================  SCRIPT_CHANGE:
GetNextOrderDate

   '  --------------------------------------------------------------
   '   SCRIPT NAME:     GetNextOrderDate
   '   BLOX TYPE:       Script FUNCTION
   '   CODE VERSION:    1.0
   '   CREATION DATE:   20140214
   '   LAST UPDATE:     20140214
   '   TRADING BLOX:    4.x or later versions
   '   PROGRAMMER:      Roger Rines
   '  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   '   DESCRIPTION:  Returns Next Allow Order Generation Date
   '
   '   USE: To find End-of-Date period order dates
   '
   '   '  Used to determine next valid order month
   '   Ref: sOrderMonths = "1,2,3,4,5,6,7,8,9,10,11,12"
   '
   '   CODE FUNCTION CALL:
   '  iNextOrderDate = script.Execute("GetNextOrderDate", _
   '                                    iAnyYYYYMMDD, sAllowMonths )
   '        OR
   '  PRINT script.Execute("GetNextOrderDate", _
   '                          iAnyYYYYMMDD, sAllowMonths )
   '  ==============================================================
   '  GetNextOrderDate SCRIPT - START
   '  ==============================================================
   '  Function Parameter Variables
   VARIABLES: iYYYYMMDD_GNOD, iTestYear_GNOD       Type: Integer
   VARIABLES: iMonthNdx_GNOD, iStepCount_GNOD      Type: Integer
   VARIABLES: iTempMth_GNOD,  iNextOrderDate_GNOD  Type: Integer
   VARIABLES: sOrderMonths_GNOD, sMsg_GNOD         Type: String
   '  --------------------------------------------------------------
   '  Assign ParameterList Items to Parameter Variables
   iYYYYMMDD_GNOD = script.parameterList[1]          '  INTEGER
   sOrderMonths_GNOD = script.stringParameterList[1] '  STRING
   '  --------------------------------------------------------------
   '  Ensure Date Passed is a Valid Date
   If script.Execute("IsValidDate", iYYYYMMDD_GNOD) THEN
      '  Get Order Generation Month
      iMonthNdx_GNOD = Month(iYYYYMMDD_GNOD)
      '  Get Date's Current Year
      iTestYear_GNOD = Year(iYYYYMMDD_GNOD)
      '  -----------------------------------------------------------
      '  Reset Working Variables
      iStepCount_GNOD = 1
      iTempMth_GNOD = 0
      '  -----------------------------------------------------------
      '  Loop Unitl an Allowed Order Month is Found
      While iTempMth_GNOD = 0
         '  Get each Month field for a Month Value
         iTempMth_GNOD = GetField(sOrderMonths_GNOD, iMonthNdx_GNOD)
         '   If Return shows Month = 0,...
         If iTempMth_GNOD = 0 THEN            
            '  When Field Pointer is December,...
            If iMonthNdx_GNOD = 12 THEN
               '  Reset Field Pointer to January 
               iMonthNdx_GNOD = 1
               '  Increment Year when December Moves to January
               iTestYear_GNOD = iTestYear_GNOD + 1
            ELSE    
               '  Increment the Field Pointer value
               iMonthNdx_GNOD = iMonthNdx_GNOD + 1
            ENDIF
         ELSE
            '  Use Found Trigger Month as Trigger Month Target
            iMonthNdx_GNOD = iTempMth_GNOD
         ENDIF '  iTempMth_GNOD = 0
      ENDWHILE '  iTempMth_GNOD = 0
      '  -----------------------------------------------------------
      '  Get Next Last Trade Date of Allowed Month
      iNextOrderDate_GNOD = script.Execute("LastTradeDateOfMonth", _
                                           iTestYear_GNOD, iMonthNdx_GNOD )
      '  -----------------------------------------------------------
   ELSE
      '  -----------------------------------------------------------
      '  Generate & Display a User Warning Report
      sMsg_GNOD = "Date Error: " + AsString(iYYYYMMDD_GNOD, 0) + Chr(10)_
                  + "Test Date: " + AsString(test.currentDate, 0)  + Chr(10)_
                  + "Simulation Must Terminate Until Date Error Corrected!"
      '  Reset Next Order Date Return Value
      iNextOrderDate_GNOD = UNDEFINED
      '  ERRORS ABORTS SIMULATION
      test.AbortSimulation( sMsg_GNOD )
      '  -----------------------------------------------------------
   ENDIF '  IsValidDate
   '  --------------------------------------------------------------
   '  Return Function Value
   script.SetReturnValue( iNextOrderDate_GNOD )
   '  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   '  ==============================================================
   '  GetNextOrderDate SCRIPT - END
   '  ==============================================================

===================  SCRIPT_CHANGE:
GetShortMonthName
===================  SCRIPT_CHANGE:
IsValidDate

   '  ==============================================================
   '   SCRIPT NAME:     IsValidDate
   '   BLOX TYPE:       Script FUNCTION
   '   CODE VERSION:    1.0    
   '   CREATION DATE:   20140122
   '   LAST UPDATE:     20140122
   '   TRADING BLOX:    4.3
   '   PROGRAMMER:      Roger Rines
   '  --------------------------------------------------------------
   '   DESCRIPTION:  Function = TRUE if valid, FALSE != Valid
   '
   '   USE: Date validity test.
   '   
   '   CODE FUNCTION CALL:
   '     Function_Result = script.Execute("IsValidDate", iAnyYMD)
   '        OR
   '     PRINT script.Execute("IsValidDate", iAnyYMD)
   '  --------------------------------------------------------------
   '  IsValidDate FUNCTION - START
   '  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   '  Function Parameter Variables
   VARIABLES: iAnyYMD_IVD, iJulTest_IVD        Type: Integer
   '  --------------------------------------------------------------
   '  Parameter to Working variable
   iAnyYMD_IVD = script.parameterList[1]  '  INTEGER
   
   '  Convert Date to Julian Date Number
   iJulTest_IVD = DateToJulian(iAnyYMD_IVD)
   
   '  If Date Conversions match offered date,...
   If iAnyYMD_IVD = JulianToDate(iJulTest_IVD) THEN
      '  Function Return TRUE
      script.SetReturnValue( TRUE )
   ELSE
      '  Function Return FALSE
      script.SetReturnValue( FALSE )
   ENDIF   
   '  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   '  IsValidDate FUNCTION - END
   '  ==============================================================

===================  SCRIPT_CHANGE:
IsWorkDay
===================  SCRIPT_CHANGE:
JulianDate_WeekNumber
===================  SCRIPT_CHANGE:

   '  ==============================================================
   '   SCRIPT NAME:     LastDayOccurance
   '   BLOX TYPE:       Script FUNCTION 
   '   CODE VERSION:    1.0    
   '   CREATION DATE:   20080722
   '   LAST UPDATE:     20140123
   '   TRADING BLOX:    4.0 or later
   '   PROGRAMMER:      Roger Rines
   '  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   '   DESCRIPTION:  This function returns the Julian day value for
   '                 the last occurance of any day in the month.             
   '   USE: 
   '     To find the last day occurance, set:
   '        DayOfWeekNum = 1  '  Last Monday in Month
   '   
   '   CODE FUNCTION CALL:
   '     Function_Result = Script.Execute( "LastDayOccurance", _
   '                                         nYear, nMonth, _
   '                                         DayOfWeekNum)
   '        OR
   '     PRINT Script.Execute( "LastDayOccurance", nYear, nMonth, _
   '                                                     DayOfWeekNum)
   '  --------------------------------------------------------------
   '  LastDayOccurance FUNCTION - START
   '  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   '  Function Parameter Variables
   VARIABLES: nYear_LDO, nMonth_LDO, DayOfWeekNum_LDO Type: Integer
   '  Function Working Variables
   VARIABLES: DayNum_LDO, LastDay_LDO                 Type: Integer
   VARIABLES: MonthDayCount_LDO, ThisDate_LDO         Type: Integer
   '  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   '  Assign ParameterList Items to Parameter Variables
   '  so that Code is Self-Documenting, and so users can
   '  easily see parameter requirements.
   nYear_LDO        = script.parameterList[1]  '  INTEGER
   nMonth_LDO       = script.parameterList[2]  '  INTEGER
   DayOfWeekNum_LDO = script.parameterList[3]  '  INTEGER
   '  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   If nYear_LDO = 0 OR nMonth_LDO = 0 OR DayOfWeekNum_LDO > SATURDAY THEN 
      '  EXIT FUNCTION
      LastDay_LDO = -1
   ELSE   
      '  Find the number of days in the month
      'MonthDayCount = Script.Execute( "DaysInMonth", nYear_LDO, nMonth_LDO)
      MonthDayCount_LDO = DaysInMonth(nMonth_LDO, nYear_LDO)

      '  Calculate the Julian number for the first day of the month
      ThisDate_LDO = (nYear_LDO * 10000) + (nMonth_LDO * 100) _
                           + MonthDayCount_LDO
      LastDay_LDO = DateToJulian(ThisDate_LDO)

      '  Determine which day is the last day in the month
      '  Get the first of the month's day number
      DayNum_LDO = script.Execute( "DayOfWeekJulian", LastDay_LDO )
   
      '  Adjust Julian Number based upon where the last day happens
      If DayNum_LDO > DayOfWeekNum_LDO THEN
         '  Backup up needed days
         LastDay_LDO = LastDay_LDO + (DayOfWeekNum_LDO - DayNum_LDO)
      ELSE
         If DayNum_LDO < DayOfWeekNum_LDO THEN
            '   Jump Back a week the adjust
            LastDay_LDO = LastDay_LDO - 7 + (DayOfWeekNum_LDO _
                                                - DayNum_LDO)   
         ENDIF '  DayNum < DayOfWeekNum
      ENDIF '  DayNum > DayOfWeekNum
   ENDIF '  nYear_LDO = 0 OR nMonth_LDO = 0 OR DayOfWeekNum > Saturday
   '  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   '  Return Function Value
   script.SetReturnValue( LastDay_LDO )
   '  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   '  LastDayOccurance FUNCTION - END
   '  ==============================================================

===================  SCRIPT_CHANGE:
LastTradeDateOfMonth

   '  ==============================================================
   '   SCRIPT NAME:     LastTradeDateOfMonth
   '   BLOX TYPE:       Script FUNCTION 
   '   CODE VERSION:    1.0    
   '   CREATION DATE:   20100125
   '   LAST UPDATE:     20140123
   '   TRADING BLOX:    2.3.b7 or later
   '   PROGRAMMER:      Roger Rines
   '  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   '
   '   DESCRIPTION:  This function returns the Last Trade Date in a 
   '                 standard trading week of Monday to Friday.  
   '                 Holidays where an exchange is closed are not 
   '                 accomodated without regional calendar maintenance.
   '   USE: 
   '     nYear  = 2007  '  Year for Month
   '     nMonth = 2     '  February
   '         
   '   CODE FUNCTION CALL:
   '     TradeDayCount = Script.Execute( "LastTradeDateOfMonth", _
   '                                               nYear, nMonth )
   '         OR
   '     PRINT Script.Execute( "LastTradeDateOfMonth", nYear, nMonth )
   '  --------------------------------------------------------------
   '  LastTradeDateOfMonth FUNCTION - START
   '  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   '  Function Parameter Variables
   VARIABLES: nYear_LTDoM, nMonth_LTDoM Type: Integer
   '  Function Working Variables
   VARIABLES: TradeDayCount_LTDoM, LastTradeDate_LTDoM Type: Integer
   '  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   '  Assign ParameterList Items to Parameter Variables
   nYear_LTDoM       = script.parameterList[1]  '  INTEGER
   nMonth_LTDoM      = script.parameterList[2]  '  INTEGER
   '  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   '  Ensure There is Correct Calling Information
   If nYear_LTDoM = 0 OR nMonth_LTDoM = 0 THEN 
      '  EXIT FUNCTION
      LastTradeDate_LTDoM = -1   '  Report Error
   ELSE         
      TradeDayCount_LTDoM = script.Execute( "GetMonthTradeDays", _
                                             nYear_LTDoM, nMonth_LTDoM )
      
      '  Retrieve the Julian Date at the Adjusted TradeDayIndex Location
      LastTradeDate_LTDoM = JulianToDate(_
                              MonthTradeDatesJulian[TradeDayCount_LTDoM])
   ENDIF '  nYear_LTDoM = 0 OR nMonth = 0
   '  --------------------------------------------------------------
   '  Return Function Value
   script.SetReturnValue( LastTradeDate_LTDoM )
   '  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   '  LastTradeDateOfMonth FUNCTION - END
   '  ==============================================================

===================  SCRIPT_CHANGE:
MakeEuroDate
===================  SCRIPT_CHANGE:
MakeUSDate_iYMD
===================  SCRIPT_CHANGE:
MoveTradeDaysBack
===================  SCRIPT_CHANGE:
NextBiWeekDate

   '  ==============================================================
   '   SCRIPT NAME:     NextBiWeekDate
   '   BLOX TYPE:       Script FUNCTION 
   '   CODE VERSION:    1.0    
   '   CREATION DATE:   20140620
   '   LAST UPDATE:     20140620
   '   TRADING BLOX:    3.4.0 or later
   '   PROGRAMMER:      Roger Rines
   '  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   '   DESCRIPTION:  This function generates a YMD date that is
   '                 14-calendar later than the date provided.
   '   USE: When a there is need for a date that is 2-weeks later
   '
   '   CODE FUNCTION CALL:
   '     Function_Result = script.Execute("NextBiWeekDate", iAnyTestDate)
   '        OR                             NBWD
   '     PRINT script.Execute("GetNextBiWeekNum", iAnyTestDate)
   '  --------------------------------------------------------------
   '  NextBiWeekDate - FUNCTION START
   '  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   '  Function Parameter Variables
   VARIABLES: iAnyTestDate_NBWD                 Type: Integer
   '
   '  Function Working Variables
   VARIABLES: iJulTestDate_NBWD, iNewBiWeekDate Type: Integer
   VARIABLES: iJulTestDate_NBWD                 Type: Integer
   '  --------------------------------------------------------------
   '  Assign ParameterList Items to Parameter Variables
   iAnyTestDate_NBWD = script.parameterList[1]
   '  --------------------------------------------------------------
   '  Reset Bi-Week Date variable
   iNewBiWeekDate = -1
   
   '  Whenn a test date is available,...
   If iAnyTestDate_NBWD > 0 THEN
      '  Convert Current date to a Julian Date
      iJulTestDate_NBWD = DateToJulian(iAnyTestDate_NBWD) + 14
      '  Convert New Bi-Week Julian to Calendar Date
      iNewBiWeekDate = JulianToDate(iJulTestDate_NBWD)
   ENDIF '  iAnyTestDate_NBWD = 0
   '  --------------------------------------------------------------
   '  Return Function Value
   script.SetReturnValue( iNewBiWeekDate )
   '  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   '  NextBiWeekDate - FUNCTION END
   '  ==============================================================

===================  SCRIPT_CHANGE:
NextDayOfWeekDate

===================  SCRIPT_CHANGE:
NthDayOccurance
===================  SCRIPT_CHANGE:
NthLastTradeDay
===================  SCRIPT_CHANGE:
NthTradeDay
===================  SCRIPT_CHANGE:
TradeDayOfMonth
===================  SCRIPT_CHANGE:
TradeDayOfWeek
===================  SCRIPT_CHANGE:
TradeDayOfYear
===================  SCRIPT_CHANGE:
WeeksBetweenTwoDates
===================  SCRIPT_CHANGE:

===================  SCRIPT_CHANGE:
